package com.qmth.exam.reserve.cache;

import com.qmth.exam.reserve.bean.login.LoginUser;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.concurrent.TimeUnit;

/**
 * 登录用户会话管理
 */
@Component
public class LoginSessionManager {

    private final long SESSION_TIMEOUT = 60;

    @Resource
    private RedisClient redisClient;

    public LoginUser getLoginSession(String sessionId) {
        return redisClient.get(CacheConstants.CACHE_SESSION_PREFIX + sessionId, LoginUser.class, SESSION_TIMEOUT, TimeUnit.MINUTES);
    }

    public void addLoginSession(LoginUser session) {
        redisClient.set(CacheConstants.CACHE_SESSION_PREFIX + session.getSessionId(), session, SESSION_TIMEOUT, TimeUnit.MINUTES);
    }

    public void removeLoginSession(String sessionId) {
        redisClient.delete(CacheConstants.CACHE_SESSION_PREFIX + sessionId);
    }

}
